
#ifndef __bluetoothchannel_h__
#define __bluetoothchannel_h__

#define BTC_MAX_ADDR_SIZE 256
#define BTC_MAX_TTY_LEN 1024
#define CANCEL_POLL_INTERVAL 100000 //us
//PLEASECHECK TODO remove Victor, should this be local to bluetoothchannel.cpp? #define MAX_CONNECTIONS 1

#include <sys/ioctl.h>
#include <sys/time.h>


#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <termios.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/socket.h>

#ifndef DEBUG
#include <bluetooth/bluetooth.h>
#include <bluetooth/hci.h>
#include <bluetooth/hci_lib.h>
#include <bluetooth/rfcomm.h>
#endif


class BluetoothChannel
{
public:

  BluetoothChannel();

  int	Initialize(char* address, int channel);

  int	Open();
  int	Open(volatile int& aCancel);
  int	Close();

  int	Listen(int aChannel, volatile int& aCancel);
  int	Send(char* aBuffer, int aSize, volatile int& aCancel );
  int	Receive(char* aBuffer, int* aBufferLength);

//  int	Send(const unsigned char* aBuffer, int aBufferLength);
  int	Receive(unsigned char* aBuffer, int aBufferLength, int aTimeout);
 
  int	SendBinary(const unsigned char* aBuffer, int aBufferLength);
  int	ReceiveBinary(char* aBuffer, int aBufferLength, int aTimeout);

  int	CreateTTY(int dev_id);
  bool	IsTTYBusy();
  char*	GetTTY();
  int	ReleaseTTY();

  char*	GetAddress();
  int   CmpAddress(char* aAddress);
  int	GetChannel();

  //checks if low level ACL link is open
  int	IsAclLinkActive();
  //closes low level ACL link
  void  DestroyAclLink();

private:
  char	btAddr[BTC_MAX_ADDR_SIZE];
  int	btChannel;
  int	btFd; // socket descriptor
  int	btDev; // device descriptor (used for ppp)
  char  btTTY[BTC_MAX_TTY_LEN];

private:
  int	UsesRFCOMM(char *path, char *dev);
  int	FindPid(int id, pid_t *pid);

};


#endif // __bluetoothchannel_h__


